cypress-get-react-component
===

[![NPM](https://nodei.co/npm/cypress-get-react-component.svg?downloads=true)](https://npmjs.org/package/cypress-get-react-component)


[![Build Status](https://travis-ci.com/flotwig/cypress-get-react-component.svg?branch=master)](https://travis-ci.com/flotwig/cypress-get-react-component)

A plugin for Cypress to .get React components by name or by ECMAScript class.

Currently a **work in progress**.

### Installation

In your repo:

```shell
yarn add --dev cypress-get-react-component
```

In your `cypress/support/commands.js`:

```js
require('cypress-get-react-component').install();
```

### Usage

See [spec.js](https://github.com/flotwig/cypress-get-react-component/blob/master/cypress/integration/spec.js) for more usage examples.

#### By component name

```js
cy.getReactComponent('FooComponent').then(...)
```

#### By component class

```js
const FooComponent = require('../../src/FooComponent.js')
cy.getReactComponent(FooComponent).then(...)
```
