"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class GetReactComponent {
    static isReactComponent(element, esClass) {
        const reactKey = GetReactComponent.findReactKey(element);
        const anyElement = element;
        if (reactKey !== undefined) {
            const subject = typeof esClass === 'string'
                ? esClass
                : esClass.name;
            return subject === anyElement[reactKey]._debugOwner.type.name;
        }
        return false;
    }
    static getInstanceFromElement(element) {
        const reactKey = GetReactComponent.findReactKey(element);
        const anyElement = element;
        debugger;
        if (reactKey !== undefined) {
            return anyElement[reactKey]._debugOwner;
        }
    }
    static install() {
        // @ts-ignore
        Cypress.Commands.add('getReactComponent', {
            prevSubject: ['optional', 'element']
        }, (subject, arg1) => {
            // @ts-ignore
            return (subject ? cy.wrap(subject).get('*') : cy.get('*'))
                .then((elements) => {
                return elements.toArray()
                    .filter((element) => {
                    return GetReactComponent.isReactComponent(element, arg1);
                });
            });
        });
        // @ts-ignore
        // Cypress.Commands.add('component', {
        //     prevSubject: ['element']
        // }, (subject: any) => {
        //     return subject.map((element: any) => {
        //         return GetReactComponent.getInstanceFromElement(element)
        //     })
        // })
    }
}
GetReactComponent.findReactKey = function (element) {
    return Object.keys(element).find(key => key.substring(0, 23) === '__reactInternalInstance');
};
exports.default = GetReactComponent;
